//
// ~Ǎ쐬
//
// written by T.Noda
//
// 2001/07/17 Ver 0.0.1 ~ǁ|}
// 2001/07/18 Ver 0.0.2 ~ǁ|
// 2001/07/23 Ver 0.0.3 ǑWJQsC
// 2001/08/03 Ver 0.0.4 ΐSĒ`ɑΉiMȂo[Wj
//
// D1:ǒa D2:}ǒa H: D:ΐS
//
//
//************************************
//
//  f[^ւ
//
//************************************
procedure SwapValue(var SA : double; var EA : double);
var
  temp : double;
begin
  temp := SA;
  SA := EA;
  EA := temp;
end;
//************************************
//
//  a擾
//
//************************************
function RadiusGet(px1 : double; py1 : double; px2 : double; py2 : double; px3 : double; py3 : double) : double;
var
  L1, L2, L3 : double;
begin
  L1 := Distance(px1, py1, px2, py2);
  L2 := Distance(px2, py2, px3, py3);
  L3 := Distance(px3, py3, px1, py1);
  Result := 0.5*L2/(sin(ArcCos((L1*L1+L3*L3-L2*L2)/(2.0*L1*L3))));
end;
//************************************
//
//  SW擾
//
//************************************
procedure CenterPointGet(var x0 : double; var y0 : double; x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double);
var
  a1, a2, b1, b2, xm1, ym1, xm2, ym2, ang1, ang2 : double;
  flg1, flg2 : boolean;
begin
  xm1 := 0.5*(x1+x2);  // _擾
  ym1 := 0.5*(y1+y2);
  xm2 := 0.5*(x2+x3);
  ym2 := 0.5*(y2+y3);
  ang1 := PosToAngl(x1, y1, x2, y2)+90.0;
  if ang1 > 360.0 then
  begin
    ang1 := ang1-360.0;
  end;
  ang2 := PosToAngl(x2, y2, x3, y3)+90.0;
  if ang2 > 360.0 then
  begin
    ang2 := ang2-360.0;
  end;
  if (ang1=90.0)OR(ang1=270.0) then
  begin
    x0 := xm1;
    flg1 := true;
  end
  else
  begin
    a1 := tan(ang1);
    b1 := ym1-a1*xm1;
    flg1 := false;
  end;
  if (ang2=90.0)OR(ang2=270.0) then
  begin
    x0 := xm2;
    flg2 := true;
  end
  else
  begin
    a2 := tan(ang2);
    b2 := ym2-a2*xm2;
    flg2 := false;
  end;
  if flg1 = true then
  begin
    y0 := a2*x0+b2;
  end
  else if flg2 = true then
  begin
    y0 := a1*x0+b1;
  end
  else
  begin
    x0 := -(b2-b1)/(a2-a1);
    y0 := -(a1*b2-a2*b1)/(a2-a1);
  end;
end;
//************************************
//
//  ~ʕԕ` 2001/07/19
//
//************************************
procedure PrintArc(x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double; xm : double);
var
  x0, y0, r, SA, EA : double;
begin
  r := RadiusGet(x1, y1, x2, y2, x3, y3);
  CenterPointGet(x0, y0, x1, y1, x2, y2, x3, y3);
  SA := PosToAngl(x0, y0, x1, y1);
  EA := PosToAngl(x0, y0, x3, y3);
  if EA < SA then
    begin
      SwapValue(SA, EA);
    end;
  if Abs(EA-SA) > 180.0 then
    begin
      SwapValue(SA, EA);
    end;
  AnglCheck(SA, EA);
  Arc(x0, y0, r, SA, EA);
  x0 := 2.0*xm-x0;
  SA := 540.0-SA;
  EA := 540.0-EA;
  Arc(x0, y0, r, EA, SA);
end;
//************************************
//
//  CvO
//
//************************************
Program CROSSCYLINDER;
var
  x, y : Array of double;
  D1, D2, H, D, A, L, A0, ly : double;
  i : integer;

Begin
  AddImage(20, 20, 'CROSSCYLINDER_PARAM.BMP');
  AddLabel(130, 20, 95, 13, 'ǒa(D1)');
  AddLabel(130, 50, 95, 13, '}ǒa(D2)');
  AddLabel(130, 80, 95, 13, '}Ǎ(H)');
  AddLabel(130, 110, 95, 13, 'ΐS(D)');
//  AddLabel(130, 140, 95, 13, 'px(A)');
//  AddLabel(130, 170, 95, 13, 'ǒ(L)');
  AddEdit(1, 230, 20, 50, 21, '');
  AddEdit(2, 230, 50, 50, 21, '');
  AddEdit(3, 230, 80, 50, 21, '');
  AddEdit(4, 230, 110, 50, 21, '');
//  AddEdit(5, 230, 140, 50, 21, '');
//  AddEdit(6, 230, 170, 50, 21, '');
  AddCheckBox(1, 20, 160, true, '⏕}'); // `FbN{bNX
  AddCheckBox(2, 20, 180, false, 'ǓWJ'); // `FbN{bNX
  If ShowDlg(300, 250,'~Ǎ}_CAO') <> True Then
    Exit;
  D1 := StrToFloat(GetDlgText(1)); // ɕϊ
  D2 := StrToFloat(GetDlgText(2));
  H := StrToFloat(GetDlgText(3));
  D := StrToFloat(GetDlgText(4));
//  A := StrToFloat(GetDlgText(5));
//  L := StrToFloat(GetDlgText(6));

  if (D1 < 0.0) OR (D2 < 0.0) OR (D1 < D2) OR ((H < 0.5*D1) AND (CheckBoxChecked(2)=false)) then
  begin
    OkMsgBox('̓f[^Ɍ肪܂B');
    exit;
  end;
  A0 := ArcSin(2.0*D/D1);
  SetArrayLength(x, 6);
  SetArrayLength(y, 10);
  Message('zuʒu͂ĉB');
  if GetPos(x[5], y[5]) = false then
  begin
    exit.
  end;
  LineType(0);  // 
  PenNo(1);     // yԍ
  if CheckBoxChecked(2) then  // ǓWJ
  begin
    x[0] := x[5];
    y[0] := y[5];
    if CheckBoxChecked(1) then  // ⏕
    begin
      LineType(3);  // 
      Line(x[0]-0.25*D2, y[0], x[0]+0.25*D2, y[0]);
      Line(x[0], y[0]-0.25*D2, x[0], y[0]+0.25*D2);
      LineType(0);  // 
    end
    else
    begin
      Point(x[0], y[0]);
    end;
    for i:=0 to 12 do
    begin
      x[4] := x[0]+0.5*D2*cos(i*7.5);
      ly := D+0.5*D2*sin(i*7.5);
      if ly > 0.5*D1 then
      begin
        ly := 0.5*D1;
      end;
      y[4] := y[0]+(D1*Pi*(ArcSin(2.0*ly/D1)-A0))/360.0;
      y[9] := y[0]-(D1*Pi*(A0-ArcSin(2.0*(D-0.5*D2*sin(i*7.5))/D1)))/360.0;
      if i=0 then
      begin
        x[1] := x[4];
        y[1] := y[4];
        y[6] := y[9];
      end
      else if (i mod 2) = 1 then
      begin
        x[2] := x[4];
        y[2] := y[4];
        y[7] := y[9];
      end
      else
      begin
        x[3] := x[4];
        y[3] := y[4];
        y[8] := y[9];
        PrintArc(x[1], y[1], x[2], y[2], x[3], y[3], x[0]);
        PrintArc(x[1], y[6], x[2], y[7], x[3], y[8], x[0]);
        x[1] := x[3];
        y[1] := y[3];
        y[6] := y[8];
      end;
    end;
  end
  else  // }ǓWJ
  begin
    x[0] := x[5]+0.5*D2*Pi;
    y[0] := y[5]+H-0.5*D1*cos(ArcSin(2.0*(D-0.5*D2)/D1));
    Line(x[5], y[5], x[5], y[0]);
    Line(x[5], y[5], x[5]+D2*Pi, y[5]);
    Line(x[5]+D2*Pi, y[5], x[5]+D2*Pi, y[0]);
    for i:=0 to 24 do
    begin
      x[4] := x[0]+D2*Pi*i/48.0;
      ly := D+0.5*D2*cos(i*7.5);
      if ly > 0.5*D1 then
      begin
        ly := 0.5*D1;
      end;
      y[4] := y[5]+H-0.5*D1*cos(ArcSin(2.0*ly/D1));
      if i=0 then
      begin
        x[1] := x[4];
        y[1] := y[4];
      end
      else if (i mod 2) = 1 then
      begin
        x[2] := x[4];
        y[2] := y[4];
      end
      else
      begin
        x[3] := x[4];
        y[3] := y[4];
        PrintArc(x[1], y[1], x[2], y[2], x[3], y[3], x[0]);
        x[1] := x[3];
        y[1] := y[3];
      end;
      if CheckBoxChecked(1) AND ((i mod 2)=0) AND (i < 24) then  // ⏕`
      begin
        LineType(2);  // 
        Line(x[0]-D2*Pi*i/48.0, y[5], x[0]-D2*Pi*i/48.0, y[4]);
        Line(x[4], y[5], x[4], y[4]);
        LineType(0);  // 
      end;
    end;
  end;
End.
